import numpy as np
import pandas as pd

# Print better
from rich.console import Console
console = Console()

# --- function view df ---
def view_df(data, limit=None):

    for i in range(len(data.columns)):

        # Define variables
        q = i
        x = i + (i + (i + 1))
        y = i + (i + (i + 1)) + 1
        z = i + (i + (i + 1)) + 2
        b = len(data.columns)-1

        # No limit
        if not limit:
            
            # This is for ODD
            if len(data.columns) % 2 == 1:

                if q < 1:
                    with pd.option_context\
                        ('display.max_rows', 6, \
                            'display.max_columns', None,
                            'display.width', 70):

                        # Print first 4
                        print('\n')
                        print('First and last column (Red and Green')
                        print('\n')
                        console.print(data.iloc[:, np.r_[q]], style='red')
                        console.print(data.iloc[:, np.r_[b]],\
                             style='green')
                        print('\n')
                        console.print(data.iloc[:, np.r_[x, y, z]],\
                            style='blue')
                        print('\n')

                elif x < len(data.columns) or y < len(data.columns) or\
                        z < len(data.columns):

                        try:
                            with pd.option_context\
                            ('display.max_rows', 6, \
                                'display.max_columns', None,
                                'display.width', 70):

                                # Print rest
                                print('\n')
                                console.print(data.iloc[:, np.r_[x, y, z]],\
                                    style='yellow')
                                print('\n')
                        except:
                            print('\n')
                            console.print("COLNUM QTY IS ODD", style='red')
                            print('\n')

                        

            # This is for EVEN
            elif len(data.columns) % 2 != 1:
                if q < 1:
                    with pd.option_context\
                        ('display.max_rows', 6, \
                            'display.max_columns', None,
                            'display.width', 70):

                        # Print first 4
                        print('\n')
                        print('First and last column (Red and Green')
                        print('\n')
                        console.print(data.iloc[:, np.r_[q]], style='red')
                        console.print(data.iloc[:, np.r_[b]],\
                             style='green')
                        print('\n')
                        console.print(data.iloc[:, np.r_[x, y, z]],\
                            style='blue')
                        print('\n')

                elif x < len(data.columns) or y < len(data.columns) or\
                        z < len(data.columns):

                        try:

                            with pd.option_context\
                                ('display.max_rows', 6, \
                                    'display.max_columns', None,
                                    'display.width', 70):

                                # Print rest
                                print('\n')
                                console.print(data.iloc[:, np.r_[x, y, z]],\
                                    style='yellow')
                                print('\n')
                        
                        except:
                            console.print("COLUMN QTY IS EVEN", style='green')

        # With Limit
        elif limit:

            for u in range(limit):

                t = u
                j = u + (u + (u + 1))
                k = u + (u + (u + 1)) + 1
                l = u + (u + (u + 1)) + 2

                if t < 1:
                    
                    with pd.option_context\
                        ('display.max_rows', 6, \
                            'display.max_columns', None,
                            'display.width', 70):

                        # Print first 4
                        console.print(data.iloc[:, np.r_[t]], style='red')
                        console.print(data.iloc[:, np.r_[j, k, l]],\
                            style='blue')
                
                elif j < len(range(limit)) or k < len(range(limit)) or\
                    l < len(range(limit)):
                    
                    with pd.option_context\
                        ('display.max_rows', 6, \
                            'display.max_columns', None,
                            'display.width', 70):

                        # Print rest
                        print('\n')
                        console.print(data.iloc[:, np.r_[j, k, l]],\
                            style='yellow')
                        print('\n')
            
            break

# --- function view manual ---
def view_manual(data=None,show_cols=False,option_1=None,\
    option_2=None,option_3=None):

    if show_cols == True:
        # Print columns
        console.print({data.columns.get_loc(c): c \
            for idx, c in enumerate(data.columns)})


    if show_cols == False:
        # Simple data frame
        with pd.option_context('display.max_rows', 6, \
            'display.max_columns', None,
            'display.max_colwidth', 70):

            # Print
            console.print(data.iloc[:, np.r_[option_1,option_2,option_3]],\
                style='magenta')